Subject: Re: bug#70138: Do not intercept C-TAB on Haiku OS

From: Po Lu <[email-masked]>
Date: Tue, 02 Apr 2024 21:00:58 +0800

Tor-björn Claesson <[email-masked]> writes:

> Hello! 
>
> On Haiku, C-TAB switches between application windows. Emacs
> unfortunately intercepts this keystroke, breaking window switching.
>
> This patch makes Emacs instead pass C-TAB to Haiku, while introducing
> the variable haiku-pass-control-tab-to-system, allowing the current
> behaviour.
>
> I would be grateful for feedback on this patch, and am willing to work
> on it until it is ok. If necessary, I'm happy to assign copyright.

Thanks.  Please insert an entry in etc/NEWS documenting this change, and
format the code consistently with its surroundings, thus:

> +	if (haiku_should_pass_control_tab_to_system() &&
> +	    mods & B_CONTROL_KEY && key == 38) {
> +	  BWindow::DispatchMessage (msg, handler);
> +	  return;
> +	}

  if (haiku_should_pass_control_tab_to_system ()
      && (mods & B_CONTROL_KEY) && key == 38)
    {
      BWindow::DispatchMessage (msg, handler);
      return;
    }

> +bool
> +haiku_should_pass_control_tab_to_system (void) {
> +  return haiku_pass_control_tab_to_system;
> +}

Please position the opening brace of this defun on its own line.

> +  DEFVAR_BOOL ("haiku-pass-control-tab-to-system",
> +	       haiku_pass_control_tab_to_system,
> +	       doc: /* Whether or not to pass C-TAB to the system.
> +		       Settings this variable will cause Emacs to pass C-TAB to the system (allowing window switching on Haiku), rather than intercepting it for use in Emacs."  */);
> +  haiku_pass_control_tab_to_system = true;

Please move the second paragraph of the doc string to column zero and
fill it with M-q.

Last but not least, please write ChangeLog entries for the commit
message as specified in our CONTRIBUTE document.  I'm willing to write
them on your behalf, as a first time contributor, but it would better
acquaint you with our practices to apply yourself to the task.

Thanks.

Eli, will we require copyright assignment for this change?